/**
 * Hierarchical tiling of multi-dimensional dense array.
 * Definitions and functions to manipulate HitTile types. 
 * This type defines a handler for dense arrays and sparse structures
 * with meta-information to create and manipulate hierarchical tiles. 
 *
 * @file hit_dump.h
 * @version 1.1
 * @author Arturo Gonzalez-Escribano
 * @date Sep 2012
 */

/*
 * This software is provided to enhance knowledge and encourage progress
 * in the scientific community and are to be used only for research and
 * educational purposes. Any reproduction or use for commercial purpose
 * is prohibited without the prior express written permission.
 * 
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranties of
 * merchantability and fitness for a particular purpose.
 * 
 * Copyright (c) 2007-2012, Arturo Gonzalez Escribano
 *                          Javier Fresno Bausela
 *                          Carlos de Blas Carton
 *                          Yuri Torres de la Sierra
 * All Rights Reserved.
 */



#ifndef _HitDump_
#define _HitDump_

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "hit_com.h"

//#include <hit_tile.h>
//#include "hit_error.h"
//#include "hit_shape.h"

/* 1. DEBUG: DUMP VARIABLE STRUCTURE IN stderr */
#define hit_dumpTile(var)	hit_dumpTileInternal(&(var), #var, stderr)

/* 2. DEBUG: DUMP VARIABLE STRUCTURE IN A PARTICUALR FILE FOR THIS PROCESS */
#define hit_dumpTileFile(var,prefix,comment)	{ char name[16]; sprintf(name,"%s.%d",prefix,hit_Rank); FILE *fich; fich=fopen(name, "a"); fprintf(fich, comment); hit_dumpTileInternal(&(var), #var, fich); fclose(fich); }


/* 3. PROTOTYPE FOR THE INTERNAL DUMPING FUNCTION */
void hit_dumpTileInternal(const void *var, const char * name, FILE *file);


/* END OF HEADER FILE _HitDump_ */
#endif
