/**
 * Hitmap layout private definitions.
 * A layout maps the indexes in a shape domain
 * into the processes from a virtual topology.
 * 
 * @file hit_layoutP.h
 * @version 1.1
 * @author Arturo Gonzalez-Escribano
 * @author Javier Fresno Bausela
 * @date Ago 2011
 * 
 */

/*
 * This software is provided to enhance knowledge and encourage progress
 * in the scientific community and are to be used only for research and
 * educational purposes. Any reproduction or use for commercial purpose
 * is prohibited without the prior express written permission.
 * 
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranties of
 * merchantability and fitness for a particular purpose.
 * 
 * Copyright (c) 2007-2011, Arturo Gonzalez Escribano
 *                          Javier Fresno Bausela
 *                          Carlos de Blas Carton
 *                          Yuri Torres de la Sierra
 * All Rights Reserved.
 */


#ifndef _HitLayoutP_
#define _HitLayoutP_

/**
 * Initicalizes the list of groups in a list layout.
 * @param lay The list layout.
 * @param numElementsTotal The number of elements.
 */
void hit_layout_list_initGroups(HitLayout * lay, int numElementsTotal);

/**
 * Adds a new group in a list layout.
 * @param lay The list layout.
 * @param leader The leader of the group.
 * @param np The number of processor within the group.
 */
void hit_layout_list_addGroup(HitLayout * lay, int leader, int np);

/* END OF HEADER FILE _HitLayoutP_ */
#endif
