/**
 * Physical topology contexts
 * Management of the stack of physical topologies 
 * 
 * @file hit_topContext.h
 * @version 1.0
 * @author Arturo Gonzalez-Escribano
 * @date Feb 2013
 *
 */

/*
 * This software is provided to enhance knowledge and encourage progress
 * in the scientific community and are to be used only for research and
 * educational purposes. Any reproduction or use for commercial purpose
 * is prohibited without the prior express written permission.
 * 
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranties of
 * merchantability and fitness for a particular purpose.
 * 
 * Copyright (c) 2007-2013, Arturo Gonzalez Escribano
 * All Rights Reserved.
 */


#ifndef _HitTopContext_
#define _HitTopContext_

#include "hit_topology.h"
#include "hit_layout.h"
#include "hit_error.h"

/* 1. POP THE PREVIOUS PHYSICAL TOPOLOGY CONTEXT */
void hit_topContextPop( );

/* 2. RESTRICT PHYSICAL TOPOLOGY TO A SUBSET OF PROCESSORS IN THE SAME GROUP OF A LAYOUT */
void hit_topContextPushGroup( HitLayout lay );


/* END OF HEADER FILE _HitTopContext_ */
#endif
