#ifndef _AcelNvidia_
#define _AcelNvidia_


#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "../include/hit_tile.h"
#include "../include/hit_error.h"




#ifdef __CUDACC__
extern"C"
#endif /* To allocate memory on device (NVIDIA)*/
void acelDeclDataNVIDIA (HitTile *tile, HitTile **acelTile, void **acelData, size_t typeSize);

#ifdef __CUDACC__
extern"C"
#endif /* To send data from Host to device (NVIDIA)*/		
void acelSendDataNVIDIA (HitTile *tile, void *acelData);

#ifdef __CUDACC__
extern"C"
#endif /* To receive data from device to Host (NVIDIA)*/
void acelRecvDataNVIDIA (HitTile *tile, void *acelData);

#ifdef __CUDACC__
extern"C"
#endif /* To free the hitTile variables on the acelerator (NVIDIA)*/
void acelFreeNVIDIA (HitTile *tile);

#ifdef __CUDACC__
extern"C"
void acelSendRecvDataNVIDIA( void *hostTile, void *gpuTile,int fromTo, char *name);
#endif 

#ifdef __CUDACC__
extern"C" /* To copy the data from/to Host and Gpu devices*/
void acelCopyDataFromToNVIDIA( void *hostTile, void *gpuTile, size_t size, int fromTo );
#endif 

#endif //_AcelNvidia_



