

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <stdlib.h>


#include <hit_acel.h>



/* Hit GPU_SHAPE NULL CONSTANT */
HitGpuShape  HIT_GPU_NULL	= HIT_GPUSHAPE_NULL_STATIC;

/* PHYSICAL GPU INFO*/
HitPGPUsTopology	HIT_GPUs_TOPOLOGY_INFO = HIT_GPUs_TOPOLOGY_NULL_STATIC;		//Yuri


/* 
 * 
 * To initizlize Hitmap and Cuda
 * 
 * */
void hit_cudaInit(int *pargc, char **pargv[]) {

	/* Initialize Hitmap*/		
	hit_comInit( pargc, pargv );

	/* Initialize CUDA*/			
	#ifdef HIT_COMPILE_CUDA
	get_GPU_pro();					//Getting GPUs properties   //yuri
	#endif
}




/* 
 * 
 * To allocate memory on device
 * 
 * */
void hit_acelDeclDataInternal(HitTile *tile, HitTile **acelTile, void **acelData, size_t typeSize){

	#ifdef HIT_COMPILE_CUDA
	acelDeclDataNVIDIA(tile, acelTile, acelData,typeSize);
	#endif

}//hit_acelDeclDataInternal


/* 
 * 
 * To send data from Host to device
 * 
 * */
void hit_acelSendDataInternal(HitTile *tile, void *acelData){

	#ifdef HIT_COMPILE_CUDA
	acelSendDataNVIDIA(tile, acelData);
	#endif

}//hit_acelSendDataInternal



/* 
 * 
 * To receive data from device to Host 
 * 
 * */
void hit_acelRecvDataInternal(HitTile *tile, void *accelData){

	#ifdef HIT_COMPILE_CUDA
	acelRecvDataNVIDIA(tile,accelData);
	#endif

}//hit_acelRecvDataInternal


/*
 * 
 * To free the hitTile variables on the acelerator
 * 
 * */
void hit_acelFreeInternel(HitTile *tile){

	#ifdef HIT_COMPILE_CUDA
	acelFreeNVIDIA(tile);
	#endif
	
}//hit_acelFreeInternel



/*
 * 
 * To define INOUT variables
 * 
 * */
int hit_acelTileIN_OUTInternal(int *inout,int n, ...){

	int i;
	va_list ap;

	va_start(ap, n);
	for (i=0; i<n; i++){

		inout[i]=va_arg(ap, int);

	}//for i
	va_end(ap);

	return 1;
}//hit_tileUpdateAcumCards


