/**
 * Hit deprecated functions.
 * @file hit_save.c
 * @deprecated This file contains deprecated functions.
 */

/*
 * This software is provided to enhance knowledge and encourage progress
 * in the scientific community and are to be used only for research and
 * educational purposes. Any reproduction or use for commercial purpose
 * is prohibited without the prior express written permission.
 * 
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranties of
 * merchantability and fitness for a particular purpose.
 * 
 * Copyright (c) 2007-2011, Arturo Gonzalez Escribano
 *                          Javier Fresno Bausela
 *                          Carlos de Blas Carton
 *                          Yuri Torres de la Sierra
 * All Rights Reserved.
 */


#include <hit_save.h>
#include <hit_com.h>
#include <hit_topology.h>

#ifdef notcompilethisfile

/* Hit TOPOLOGY: COMMIT */
void hit_topCommitInternal(HitTopology *topo, MPI_Comm oldComm) {
	MPI_Comm *newCom = (MPI_Comm *)malloc( sizeof( MPI_Comm ) );
	
	int ok = MPI_Comm_split( oldComm, topo->active, topo->linearRank, newCom );
	hit_mpiTestError(ok,"Failed split communicator for topology commit");
	
	topo->pTopology.lowLevel = (void *)newCom;
}

/* Hit TOPOLOGY: FREE */
void hit_topFreeInternal(HitTopology *topo, MPI_Comm *oldComm) {
	int ok = MPI_Comm_free( (MPI_Comm *)topo->pTopology.lowLevel );
	hit_mpiTestError(ok,"Failed to free communicator for topology");
	
	topo->pTopology.lowLevel = (void *)MPI_COMM_NULL;
}



/* HitCom: CREATE STRUCT MPI TYPE */
void hit_comTypeStructInternal(HitType * newType, int count, ...){

	int * lengths;
	HitType  * types;
	
	hit_malloc(lengths,sizeof(int) * (size_t) count);
	hit_malloc(types,sizeof(HitType) * (size_t) count)
	
	
	va_list ap;
	va_start(ap, count);

	int i;
	for(i=0;i<count;i++){

		lengths[i] = va_arg(ap,int);
		types[i]   = va_arg(ap,HitType);
	}
    va_end(ap);
		
	
	HitAint * displacements;
	hit_malloc(displacements,sizeof(HitAint) * (size_t) count);
	
	displacements[0] = (HitAint) 0;
	
	for(i=1; i<count; i++){
		int size;
		MPI_Type_size(types[i-1],&size);
		displacements[i] = displacements[i-1] + (HitAint) lengths[i-1] * size ;
	} 
	
	MPI_Type_create_struct(count, lengths, displacements, types, newType);
	MPI_Type_commit(newType);
	
	hit_free(displacements);
	hit_free(lengths);
	hit_free(types);

}

#endif
