

#include <hit_task.h>
#include <hit_allocP.h>
#include <hit_worker.h>


/**
 * Null variable for the HitTask
 */
HitTask HIT_TASK_NULL = HIT_TASK_NULL_STATIC;




/**
 * Allocate memory for the task.
 * @param newTaskP Task pointer.
 * @param n_elems Number of elements in the task.
 * @param baseExtent Size of the task data.
 */
void hit_taskAllocInternal(void * newTaskP, int n_elems, size_t baseExtent){

	HitTask * taskP = (HitTask*) newTaskP;
	taskP->baseExtend = baseExtent;
	taskP->weight = n_elems * ( HIT_WORKER_CONFIG.threshold_send / (double) HIT_WORKER_CONFIG.buffer_out);
	taskP->n_elems = n_elems;
	hit_malloc(taskP->data, baseExtent * (size_t) n_elems, void*);

}

/**
 * Frees the task memory.
 * @param newTaskP Task pointer.
 */
void hit_taskFree(void * newTaskP){

	HitTask * taskP = (HitTask*) newTaskP;
	hit_free(taskP->data);
	taskP->weight = 0;
	taskP->n_elems = 0;

}
