/*
 * Debug functions for test.
 *
 * @file hit_test.h
 * @version 1.0
 * @version 1.1 13-11-2011 Added the dump for bitmap shape.
 * @date 13-11-2011
 * @author Javier Fresno Bausela
 */

/*
 * This software is provided to enhance knowledge and encourage progress
 * in the scientific community and are to be used only for research and
 * educational purposes. Any reproduction or use for commercial purpose
 * is prohibited without the prior express written permission.
 * 
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranties of
 * merchantability and fitness for a particular purpose.
 * 
 * Copyright (c) 2007-2011, Javier Fresno Bausela.
 * All Rights Reserved.
 */


#include <stdio.h>
#include <stdlib.h>
#include <hitmap.h>
#include <hit_com.h>
#include <unistd.h>
#include <time.h>


#define printfd(...) { if( HIT_TOPOLOGY_INFO->selfRank == 0 ) { printf(__VA_ARGS__); fflush(stdout); }}

void dumpArray(int * array,int dims, const char * format, ...);
void dumpTopoCommon(HitTopology topo, const char * name );
void dumpTopoSelf(HitTopology topo);
void dumpListLayout(HitLayout lay, const char * name, double * weights);
void dumpSignatureLayoutCommon( HitLayout lay , const char * name );
void dumpSignatureLayoutSelf( HitLayout lay);
void dumpShape(HitShape sh);
void dumpArrayAllSec(int * array,int dims, const char * format, ...);
void printfAllSec( const char* format, ... );
void dumpCShape(HitShape shape);
void dumpBShape(HitShape shape);

#define ALL_SEQUENTIAL_BEGIN(var) \
	struct timespec var ## ts = {0,1000000}; \
	fflush(stdout); \
	int var = 0; \
	for(var=-1;var<hit_NProcs+1;var++){ \
		if(hit_Rank == var){
#define ALL_SEQUENTIAL_END(var) \
		} else { \
			nanosleep(&(var ## ts),NULL); \
		} \
		fflush(stdout); \
		MPI_Barrier(hit_Comm); \
	}
