/*
 * Debug functions for test
 *
 * @version 1.0
 * @date Jun 2010
 * @author Javier Fresno Bausela
 */

/*
 *
 * hit v1.0
 * (c) 2010, Javier Fresno Bausela
 */


#include <stdio.h>
#include <stdlib.h>
#include <hitmap.h>
#include <hit_com.h>
#include <unistd.h>
#include <time.h>


#define printfd(...) { if( HIT_TOPOLOGY_INFO.selfRank == 0 ) { printf(__VA_ARGS__); fflush(stdout); }}

void dumpArray(int * array,int dims, const char * format, ...);
void dumpTopoCommon(HitTopology topo, char * name );
void dumpTopoSelf(HitTopology topo);
void dumpListLayout(HitLayout lay, char * name, double * weights);
void dumpSignatureLayoutCommon( HitLayout lay , char * name );
void dumpSignatureLayoutSelf( HitLayout lay);
void dumpShape(HitShape sh);
void dumpArrayAllSec(int * array,int dims, char * format, ...);
void printfAllSec( const char* format, ... );
void dumpSparseShape(HitShape shape);


#define ALL_SEQUENTIAL_BEGIN(var) \
	struct timespec var ## ts = {0,1000000}; \
	fflush(stdout); \
	int var = 0; \
	for(var=-1;var<hit_NProcs+1;var++){ \
		if(hit_Rank == var){
#define ALL_SEQUENTIAL_END(var) \
		} else { \
			nanosleep(&(var ## ts),NULL); \
		} \
		fflush(stdout); \
		MPI_Barrier(*hit_Comm); \
	}
