/*
 * Test Active Ranks
 *
 * @version 1.0
 * @date Jun 2010
 * @author Javier Fresno Bausela
 */

/*
 *
 * hit v1.0
 * (c) 2010, Javier Fresno Bausela
 */

#include "debug.h"


void test(int dims, int nprocs, int ele1, int ele2){

	printf("  nprocs: %d, shape: [%d,%d]\n",nprocs,ele1,ele2);
	printf("---------------------------\n");

	int i;
	for(i=0;i<nprocs;i++){

		HIT_TOPOLOGY_INFO.numProcs = nprocs;
		HIT_TOPOLOGY_INFO.selfRank = i;
		HitTopology topo;
		HitShape shape;
		if( dims == 1){
			topo = hit_topology(plug_topPlain);
			shape = hit_shape(1,hit_sig(0,ele1-1,1));
		} else {
			topo = hit_topology(plug_topArray2D);
			shape = hit_shape(2,hit_sig(0,ele1-1,1),hit_sig(0,ele2-1,1));
		}
		HitLayout lay = hit_layout(plug_layBlocksL,topo,shape);

		printf("Processor: %2d, ",i);
		dumpArray(lay.topo.self.rank,lay.topo.numDims,"Topo ranks");
		HitRanks active = hit_layRanksToActiveRanksInternal(lay,topo.self);
		dumpArray(active.rank,lay.topo.numDims,", Active ranks");

		printf("\n");

	}


}



int main(){


	test(1,4,2,0);
	test(1,4,4,0);

	test(2,8,2,4);
	test(2,4,2,4);

	return 0;

}
