/*
 * Test BroadCastDim
 * @version 1.0
 * @date Jun 2010
 * @author Javier Fresno Bausela
 */

/*
 *
 * hit v1.0
 * (c) 2010, Javier Fresno Bausela
 */


#include "debug.h"

hit_tileNewType(int);


void test(int dims,int dim){

	printfd("\n Broadcast dim: %d\n",dim);
	printfd("---------------------------\n");

	// Make a shape
	HitShape sh;
	if(dims==2) sh = hit_shape(2, hit_sig(0,9,1),hit_sig(0,9,1));
	if(dims==3) sh = hit_shape(3, hit_sig(0,9,1),hit_sig(0,9,1),hit_sig(0,9,1));

	// Topology
	HitTopology topo;
	if(dims==2) topo = hit_topology(plug_topArray2D);
	if(dims==3) topo = hit_topology(plug_topArray3D);

	//printfAllSec("lineal rank topo: %d/%d\n",topo.pTopology.selfRank,topo.pTopology.numProcs);

	dumpArrayAllSec(topo.self.rank,3,"my coords");
	//printfd("\n");

	// Layout
	//printfd("layout start\n");

	HitLayout lay = hit_layout(plug_layBlocks,topo,sh);
	hit_layWrapNeighbors(&lay);

	//printfAllSec("lineal rank: %d/%d\n",lay.pTopology[0].selfRank,lay.pTopology[0].numProcs);

	hit_comAllowDims(lay);
	//printfAllSec("dim %d, lineal rank dim: %d/%d\n",1,lay.pTopology[2].selfRank,lay.pTopology[2].numProcs);

	HitTile_int tile;
	hit_tileDomainAlloc(&tile,sizeof(int),HIT_NONHIERARCHICAL,1,1);

	hit_tileElemAt(tile,1,0) = HIT_TOPOLOGY_INFO.selfRank;
	//printfAllSec("I have: %d\n",hit_tileElemAt(tile,1,0));


	HitRanks root = {{0,0,0,-1}};
	HitCom com = hit_comBroadcastDim(lay, dim, root, &tile, HIT_INT);

	hit_comDoBroadcast(&com);

	printfAllSec("Now, I have: %d\n",hit_tileElemAt(tile,1,0));

	hit_layoutFree(lay);




}



int main(int argc, char *argv[]){

	// Init Hitmap Comm
	hit_comInit(&argc,&argv);

	test(3,0);
	test(3,1);


	test(2,0);
	test(2,1);

	hit_comFinalize();

	return 0;

}

