/*
 * Test Group Layout
 * @version 1.0
 * @date Jun 2010
 * @author Javier Fresno Bausela
 */

/*
 *
 * hit v1.0
 * (c) 2010, Javier Fresno Bausela
 */

#include "debug.h"


double weights[20] = {1,5,8,4,2,9,7,2,7,0,8,4,5,8,7,5,1,8,3,7};


#define TOPO_PLAIN 1
#define TOPO_2D 2

void testGL(int nprocs, int elements, int topot){


	// Set the Physical topology info
	HIT_TOPOLOGY_INFO.numProcs = nprocs;
	HIT_TOPOLOGY_INFO.selfRank = 0;

	HitTopology topo;

	if(topot == TOPO_PLAIN){
		topo = hit_topology(plug_topPlain);
	}else{
		topo = hit_topology(plug_topArray2D);
	}

	HitShape shape = hit_shape(1,hit_sig(0,elements-1,1));

	HitLayout lay = hit_layout(plug_layIndependentLB, topo, shape, weights);

	//HitLayout lay = hit_layout(plug_layContiguous, topo, shape, weights);

	dumpListLayout(lay,"Contiguous",weights);

}



// Main function
int main() {

	testGL(10,3,1);
	//testGL(5,3,1);
	testGL(3,10,1);
	//testGL(10,3,1);
	//testGL(10,3,2);
	//testGL(4,7,1);

	return 0;
}

	
	

