/*
 * Test Signature Layout Blocks L
 *
 * @version 1.0
 * @date Jun 2010
 * @author Javier Fresno Bausela
 */

/*
 *
 * hit v1.0
 * (c) 2010, Javier Fresno Bausela
 */

#include "debug.h"


void test(int dims, int nprocs, int ele1, int ele2){

	int i;
	for(i=0;i<nprocs;i++){

		HIT_TOPOLOGY_INFO.numProcs = nprocs;
		HIT_TOPOLOGY_INFO.selfRank = i;
		HitTopology topo;
		HitShape shape;
		if( dims == 1){
			topo = hit_topology(plug_topPlain);
			shape = hit_shape(1,hit_sig(0,ele1-1,1));
		} else {
			topo = hit_topology(plug_topArray2D);
			shape = hit_shape(2,hit_sig(0,ele1-1,1),hit_sig(0,ele2-1,1));
		}
		HitLayout lay = hit_layout(plug_layBlocksL,topo,shape);
		if(i == 0)
			dumpSignatureLayoutCommon(lay,"BlocksL");
		printf("Processor: %2d",i);
		dumpSignatureLayoutSelf(lay);

	}

}


// Main function
int main() {

	// 4 procs, 8 data
	test(1,4,8,0);

	// 4 procs, 4 data
	test(1,4,4,0);

	// 4 procs, 2 data
	test(1,4,2,0);

	// 3 procs, 8 data
	test(1,3,8,0);

	// 3 procs, 4 data
	test(1,3,4,0);

	// 3 procs, 2 data
	test(1,3,2,0);

	return 0;
}
