/*
 * Test Signature Layout Blocks L
 *
 * @version 1.0
 * @date Jun 2010
 * @author Javier Fresno Bausela
 */

/*
 *
 * hit v1.0
 * (c) 2010, Javier Fresno Bausela
 */

#include "debug.h"

#define BLOCKS 0
#define BLOCKSX 1
#define BLOCKSF 2
#define BLOCKSL 3
#define CYCLIC 4



void test(int type, int nprocs, int nele){

	nprocs = 11;

	int i;
	for(i=0;i<nprocs;i++){

		HIT_TOPOLOGY_INFO.numProcs = nprocs;
		HIT_TOPOLOGY_INFO.selfRank = i;
		HitTopology topo;
		HitShape shape;
		HitLayout lay;

		//topo = hit_topology(plug_topPlain);
		//shape = hit_shape(1,hit_sig(0,nele-1,1));

		topo = hit_topology(plug_topArray2D);
		shape = hit_shape(2,hit_sig(0,nele-1,1),hit_sig(0,2-1,1));

		char * name = "Blocks";


		switch(type){
			case BLOCKS:
				lay = hit_layout(plug_layBlocks,topo,shape);
				name = "Blocks";
				break;
			case BLOCKSX:
				lay = hit_layout(plug_layBlocksX,topo,shape);
				name = "BlocksX";
				break;
			case BLOCKSF:
				lay = hit_layout(plug_layBlocksF,topo,shape);
				name = "BlocksF";
				break;
			case BLOCKSL:
				lay = hit_layout(plug_layBlocksL,topo,shape);
				name = "BlocksL";
				break;
			case CYCLIC:
				lay = hit_layout(plug_layCyclic,topo,shape,1);
				name = "Cyclic";
				break;
		}


		if(i == 0)
			dumpSignatureLayoutCommon(lay,name);
		printf("Processor: %2d",i);
		dumpSignatureLayoutSelf(lay);

	}

}


// Main function
int main() {

	int nprocs, nele;

	//nprocs = 3; nele = 5;
	nprocs = 5; nele = 3;
	test(BLOCKS,nprocs,nele);
	//test(BLOCKSX,nprocs,nele);
	test(BLOCKSF,nprocs,nele);
	test(BLOCKSL,nprocs,nele);
	test(CYCLIC,nprocs,nele);



	return 0;
}
