/*
 * Test Pattern
 * @version 1.0
 * @date Jun 2010
 * @author Javier Fresno Bausela
 */

/*
 *
 * hit v1.0
 * (c) 2010, Javier Fresno Bausela
 */


#include "debug.h"

hit_tileNewType(int);


void test(int pattern){


	// Topology
	HitTopology topo = hit_topology(plug_topPlain);

	HitTile_int tileA, tileB, tileC;
	hit_tileDomainAlloc(&tileA,sizeof(int),HIT_NONHIERARCHICAL,1,1);
	hit_tileDomainAlloc(&tileB,sizeof(int),HIT_NONHIERARCHICAL,1,1);
	hit_tileDomainAlloc(&tileC,sizeof(int),HIT_NONHIERARCHICAL,1,1);

	// Make a shape
	HitShape sh = hit_shape(1, hit_sig(1,hit_NProcs,1));

	// Layout
	HitLayout lay = hit_layout(plug_layBlocks,topo,sh);
	hit_layWrapNeighbors(&lay);



	hit_tileElemAt(tileA,1,0) = hit_Rank;
	hit_tileElemAt(tileB,1,0) = hit_Rank;

	HitRanks nbl = hit_layNeighbor(lay,0,-1);
	HitRanks nbr = hit_layNeighbor(lay,0,+1);

	HitRanks root = {{0,0,0,-1}};


	HitPattern p;

	if(pattern == 0){
		p = hit_pattern(HIT_PAT_ORDERED);
	}else{
		p = hit_pattern(HIT_PAT_UNORDERED);
	}



	hit_patternAdd(&p,hit_comBroadcast(lay, root, &tileB, HIT_INT));
	hit_patternAdd(&p,hit_comSendRecv(lay, nbl, &tileA, nbr, &tileC, HIT_INT));

ALL_SEQUENTIAL_BEGIN(var)
	fflush(stdout);
ALL_SEQUENTIAL_END(var)

	if(pattern == 0){
		printfd("\n Pattern Ordered\n");
	}else{
		printfd("\n Pattern Unordered\n");
	}
	printfd("---------------------------\n");

	hit_patternDo(p);

ALL_SEQUENTIAL_BEGIN(var2)
	fflush(stdout);
ALL_SEQUENTIAL_END(var2)
	printfd("---------------------------\n");

	//hit_layoutFree(lay);


}



int main(int argc, char *argv[]){

	// Init Hitmap Comm
	hit_comInit(&argc,&argv);

	test(0);
	test(1);

	hit_comFinalize();

	return 0;

}

