/*
 * test Topology Array Dims
 * @version 1.0
 * @date Jun 2010
 * @author Javier Fresno Bausela
 */

/*
 *
 * hit v1.0
 * (c) 2010, Javier Fresno Bausela
 */

#include "debug.h"




// Number of processors sets
#define SETS 6
int procs_sets[SETS] = {3,3,4,9,16,20};
int dims_sets[SETS] = {1,2,2,3,3,4};


void testTopo(int dims, int nprocs){

	int self;

	for(self=0;self<nprocs;self++){

		// Set the Physical topology info
		HIT_TOPOLOGY_INFO.numProcs = nprocs;
		HIT_TOPOLOGY_INFO.selfRank = self;

		// Create the topology
		HitTopology topo = hit_topology(plug_topArrayDims, dims);

		if(self==0){
			dumpTopoCommon(topo,"ArrayDims");
		}
		dumpTopoSelf(topo);
	}


}





// Main function
int main() {

	int set;

	for(set=0;set<SETS;set++){

		testTopo(dims_sets[set],procs_sets[set]);
	}

	return 0;
}
