/*
* Test of hit_ranks
*
* Hit v1.0
* (c) 2010, Arturo González Escribano
*           Javier Fresno Bausela
*           Carlos de Blas Cartón
*/
#include <stdio.h>
#include <stdlib.h>
#include <hitmap.h>

// Dump a integer array
void dumpArray(int * array,int dims, const char * format, ...){

	char name[1024];

	va_list args;
	va_start( args, format );
	vsprintf( name, format, args );
	va_end( args );


	if(dims == 0){
		printf("%s [X]\n",name);
		return;
	}

	int i;
	printf("%s [%d",name,array[0]);
	for(i=1;i<dims;i++) printf(",%d",array[i]);
	printf("]");

}

int main(){


	HitRanks r = hit_ranks(2,3,4);



	int i;
	HitTopology topo;
	HitRanks ranks;
	int lrank;

	HIT_TOPOLOGY_INFO.numProcs=3;
	topo = hit_topology(plug_topPlain);

	printf("Topo Plain\n");

	for(i=0;i<HIT_TOPOLOGY_INFO.numProcs;i++){
		ranks = hit_topRanksInternal(topo,i);
		lrank = hit_topRankInternal(topo,ranks);

		printf("%d -> ",i);
		dumpArray(ranks.rank,1,"");
		printf(" -> %d\n",lrank);

	}


	HIT_TOPOLOGY_INFO.numProcs=4;
	topo = hit_topology(plug_topArray2D);


	printf("Topo 2D\n");

	for(i=0;i<HIT_TOPOLOGY_INFO.numProcs;i++){
		ranks = hit_topRanksInternal(topo,i);
		lrank = hit_topRankInternal(topo,ranks);

		printf("%d -> ",i);
		dumpArray(ranks.rank,2,"");
		printf(" -> %d\n",lrank);

	}


	return 0;
	
	
}
