/*
* test of strides in tiles
*
* (c) 2010, Arturo González Escribano
*           Javier Fresno Bausela
*           Carlos de Blas Cartón
*/

#include <stdio.h>
#include <stdlib.h>
#include "hit_sparseshape.h"



int main() {
	
	HitCShape spa = hit_sparseNoWeights(15,22);
	
	spa.xadj[0] = 0;
	spa.xadj[1] = 2;
	spa.xadj[2] = 5;
	spa.xadj[3] = 8;
	spa.xadj[4] = 11;
	spa.xadj[5] = 13;
	spa.xadj[6] = 16;
	spa.xadj[7] = 20;
	spa.xadj[8] = 24;
	spa.xadj[9] = 28;
	spa.xadj[10] = 31;
	spa.xadj[11] = 33;
	spa.xadj[12] = 36;
	spa.xadj[13] = 39;
	spa.xadj[14] = 42;
	spa.xadj[15] = 44;
	
	spa.adjncy[0] = 1;
	spa.adjncy[1] = 5;
	spa.adjncy[2] = 0;
	spa.adjncy[3] = 2;
	spa.adjncy[4] = 6;
	spa.adjncy[5] = 1;
	spa.adjncy[6] = 3;
	spa.adjncy[7] = 7;
	spa.adjncy[8] = 2;
	spa.adjncy[9] = 4;
	spa.adjncy[10] = 8;
	spa.adjncy[11] = 3;
	spa.adjncy[12] = 9;
	spa.adjncy[13] = 0;
	spa.adjncy[14] = 6;
	spa.adjncy[15] = 10;
	spa.adjncy[16] = 1;
	spa.adjncy[17] = 5;
	spa.adjncy[18] = 7;
	spa.adjncy[19] = 11;
	spa.adjncy[20] = 2;
	spa.adjncy[21] = 6;
	spa.adjncy[22] = 8;
	spa.adjncy[23] = 12;
	spa.adjncy[24] = 3;
	spa.adjncy[25] = 7;
	spa.adjncy[26] = 9;
	spa.adjncy[27] = 13;
	spa.adjncy[28] = 4;
	spa.adjncy[29] = 8;
	spa.adjncy[30] = 14;
	spa.adjncy[31] = 5;
	spa.adjncy[32] = 11;
	spa.adjncy[33] = 6;
	spa.adjncy[34] = 10;
	spa.adjncy[35] = 12;
	spa.adjncy[36] = 7;
	spa.adjncy[37] = 11;
	spa.adjncy[38] = 13;
	spa.adjncy[39] = 8;
	spa.adjncy[40] = 12;
	spa.adjncy[41] = 14;
	spa.adjncy[42] = 9;
	spa.adjncy[43] = 13;

	printf("Number of edges from vertix 0: %d\n",hit_sparseNumberEdgesFromVertix(spa,0));
	
	printf("Number of edges to vertix 0: %d\n",hit_sparseNumberEdgesToVertix(spa,0));
	
	printf("Number of edges from vertix 8: %d\n",hit_sparseNumberEdgesFromVertix(spa,8));
	
	printf("Number of edges to vertix 8: %d\n",hit_sparseNumberEdgesToVertix(spa,8));

    nlist list;
	int i;
	
	list = hit_sparseEdgesFromVertix(spa, 0);
	printf("Edges from vertix 0: ");
	for(i=0;i<nlist_size(list);i++) printf("%d ",nlist_elem(list,i));
	printf("\n");
	nlist_free(list);
	
	list = hit_sparseEdgesToVertix(spa, 0);
	printf("Edges to vertix 0: ");
	for(i=0;i<nlist_size(list);i++) printf("%d ",nlist_elem(list,i));
	printf("\n");
	nlist_free(list);
	
	list = hit_sparseEdgesFromVertix(spa, 8);
	printf("Edges from vertix 8: ");
	for(i=0;i<nlist_size(list);i++) printf("%d ",nlist_elem(list,i));
	printf("\n");
	nlist_free(list);

	list = hit_sparseEdgesToVertix(spa, 8);
	printf("Edges to vertix 8: ");
	for(i=0;i<nlist_size(list);i++) printf("%d ",nlist_elem(list,i));
	printf("\n");
	nlist_free(list);
	
	return 0;
}
