/*
 * Test AlltoAll
 *
 * @version 1.0
 * @date Jun 2010
 * @author Javier Fresno Bausela
 */

/*
 *
 * hit v1.0
 * (c) 2010, Javier Fresno Bausela
 */


#include "hit_test.h"

hit_tileNewType(int);


void test(int nprocs, int selectMode){


	printfd("AlltoAll, ");
	if(selectMode == HIT_COM_TILECOORDS){
		printfd("mode = HIT_COM_TILECOORDS\n");
	}else{
		printfd("mode = HIT_COM_ARRAYCOORDS\n");
	}
	printfd("---------------------------\n");

	HitTile_int data_send;
	HitTile_int data_recv;

	HitShape shape;
	
	if(selectMode == HIT_COM_TILECOORDS){
		shape = hit_shape(1,hit_sig(0,nprocs,1));
	} else {
		shape = hit_shape(1,hit_sig(10,nprocs+10,1));
	}
	hit_tileDomainShapeAlloc(&data_send,int,shape);
	hit_tileDomainShapeAlloc(&data_recv,int,shape);

	int i;
	for(i=0;i<nprocs;i++){
		hit_tileElemAtNoStride1(data_send,i) = (hit_Rank+1) * 10 + i + 1 ;
	}

	HitShape shape_send[nprocs];
	HitShape shape_recv[nprocs];
	
	if(selectMode == HIT_COM_TILECOORDS){
		for(i=0;i<nprocs;i++){
			shape_send[i] = hit_shape(1,hit_sig(i,i,1));
			shape_recv[i] = hit_shape(1,hit_sig(i,i,1));
		}
	} else {
		for(i=0;i<nprocs;i++){
			shape_send[i] = hit_shape(1,hit_sig(i+10,i+10,1));
			shape_recv[i] = hit_shape(1,hit_sig(i+10,i+10,1));
		}
	}

	

	HitTopology topo = hit_topology(plug_topPlain);
	HitLayout lay = hit_layout(plug_layBlocks,topo,shape);
	
	HitCom com = hit_comAlltoallSelectv(lay, &data_send, shape_send, selectMode, &data_recv, shape_recv, selectMode, HIT_INT);
	hit_comDo(&com);


	ALL_SEQUENTIAL_BEGIN(varseq)

		printf("proc %d: ",hit_Rank);
		for(i=0;i<nprocs-1;i++){
			printf("%2d, ",hit_tileElemAtNoStride1(data_send,i));
		}
		printf("%2d\n",hit_tileElemAtNoStride1(data_send,nprocs-1));

	ALL_SEQUENTIAL_END(varseq)

	printfd("< all to all com >\n");

	ALL_SEQUENTIAL_BEGIN(varseq2)

		printf("proc %d: ",hit_Rank);
		for(i=0;i<nprocs-1;i++){
			printf("%2d, ",hit_tileElemAtNoStride1(data_recv,i));
		}
		printf("%2d\n",hit_tileElemAtNoStride1(data_recv,nprocs-1));

	ALL_SEQUENTIAL_END(varseq2)


}



int main(int argc, char *argv[]){

	// Init Hitmap Comm
	hit_comInit(&argc,&argv);

	test(hit_NProcs,HIT_COM_TILECOORDS);
	test(hit_NProcs,HIT_COM_ARRAYCOORDS);

	hit_comFinalize();

	return 0;

}

