
/**
 * Program to test the global to local conversion in the cShapes.
 * 
 * @file testNames.c
 * @date 28-11-2011
 * @author Javier Fresno Bausela
 */

/*
 * This software is provided to enhance knowledge and encourage progress
 * in the scientific community and are to be used only for research and
 * educational purposes. Any reproduction or use for commercial purpose
 * is prohibited without the prior express written permission.
 * 
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranties of
 * merchantability and fitness for a particular purpose.
 * 
 * Copyright (c) 2007-2011, Javier Fresno Bausela
 *
 * All Rights Reserved.
 */

#include "hit_test.h"
#include <stdio.h>
#include <stdlib.h>
#include <hitmap.h>



// Main function
int main() {


	// Shape
	HitShape shape = HIT_CSR_SHAPE_NULL;

	
	hit_cShapeAddEdge2(&shape,9,5);
	hit_cShapeAddEdge2(&shape,3,5);
	hit_cShapeAddEdge2(&shape,2,5);
	hit_cShapeAddEdge2(&shape,7,9);
	hit_cShapeAddEdge2(&shape,2,4);
	
	dumpCShape(shape);
	
	int i;
	
	for(i=0;i<10;i++){
		printf("To local: %d -> %d\n",i,hit_cShapeVertexToLocal(shape,i));
	}
	
	hit_cShapeCreateInvNames(&shape);

	dumpCShape(shape);
	for(i=0;i<10;i++){
		printf("To local: %d -> %d\n",i,hit_cShapeVertexToLocal(shape,i));
	}

	return 0;
}
